diff --git a/modules/PowerManagement_1-2/test/TPS6211x_INA219/module_test_TPS6211x_INA219.c b/modules/PowerManagement_1-2/test/TPS6211x_INA219/module_test_TPS6211x_INA219.c
new file mode 100644
index 0000000..a2b95d9
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/TPS6211x_INA219/module_test_TPS6211x_INA219.c
@@ -0,0 +1,72 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_TPS6211x_INA219.h>
+#include <aos_test_TPS6211x_INA219.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_tps6211xina219data_t _data = {
+  /* TPS6211x */ &moduleLldStepDownConverter,
+  /* INA219   */ &moduleLldPowerMonitorVsys42,
+  /* timeout  */ MICROSECONDS_PER_SECOND,
+};
+
+static AOS_TEST(_test, "TPS62113 & INA219", "step-down converter & power monitor", moduleTestTps6211xIna219ShellCb, aosTestTps6211xIna219Func, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestTps6211xIna219ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/PowerManagement_1-2/test/TPS6211x_INA219/module_test_TPS6211x_INA219.h b/modules/PowerManagement_1-2/test/TPS6211x_INA219/module_test_TPS6211x_INA219.h
new file mode 100644
index 0000000..1357595
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/TPS6211x_INA219/module_test_TPS6211x_INA219.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_TPS6211x_INA219_H
+#define MODULE_TEST_TPS6211x_INA219_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestTps6211xIna219ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_TPS6211x_INA219_H */
+
diff --git a/modules/PowerManagement_1-2/test/VCNL4020/module_test_VCNL4020.c b/modules/PowerManagement_1-2/test/VCNL4020/module_test_VCNL4020.c
new file mode 100644
index 0000000..913e762
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/VCNL4020/module_test_VCNL4020.c
@@ -0,0 +1,203 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if ((AMIROOS_CFG_TESTS_ENABLE == true) && (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR)) || defined(__DOXYGEN__)
+
+#include <module_test_VCNL4020.h>
+#include <aos_test_VCNL4020.h>
+#include <string.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_vcnl4020data_t _data = {
+  /* driver       */ NULL,
+  /* timeout      */ MICROSECONDS_PER_SECOND,
+  /* event source */ &aos.events.io,
+  /* event flags  */ 0,
+};
+
+static AOS_TEST(_test, "VCNL4020", "proximity sensor", moduleTestVcnl4020ShellCb, aosTestVcnl4020Func, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+static void _disableInterrupt(VCNL4020Driver* vcnl)
+{
+  uint8_t intstatus;
+  vcnl4020_lld_writereg(vcnl, VCNL4020_LLD_REGADDR_INTCTRL, 0, _data.timeout);
+  vcnl4020_lld_readreg(vcnl, VCNL4020_LLD_REGADDR_INTSTATUS, &intstatus, _data.timeout);
+  if (intstatus) {
+    vcnl4020_lld_writereg(vcnl, VCNL4020_LLD_REGADDR_INTSTATUS, intstatus, _data.timeout);
+  }
+  return;
+}
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestVcnl4020ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  enum {
+    UNKNOWN,
+    NNE, ENE, ESE, SSE, SSW, WSW, WNW, NNW,
+  } sensor = UNKNOWN;
+
+  // evaluate arguments
+  if (argc == 2) {
+    if (strcmp(argv[1], "-nne") == 0) {
+      sensor = NNE;
+    } else if (strcmp(argv[1], "-ene") == 0) {
+      sensor = ENE;
+    } else if (strcmp(argv[1], "-ese") == 0) {
+      sensor = ESE;
+    } else if (strcmp(argv[1], "-sse") == 0) {
+      sensor = SSE;
+    } else if (strcmp(argv[1], "-ssw") == 0) {
+      sensor = SSW;
+    } else if (strcmp(argv[1], "-wsw") == 0) {
+      sensor = WSW;
+    } else if (strcmp(argv[1], "-wnw") == 0) {
+      sensor = WNW;
+    } else if (strcmp(argv[1], "-nnw") == 0) {
+      sensor = NNW;
+    }
+  }
+
+  // handle valid sensor
+  if (sensor != UNKNOWN) {
+    aos_testresult_t res = {0, 0};
+    PCA9544ADriver* mux = NULL;
+    switch (sensor) {
+      case SSE:
+      case SSW:
+      case WSW:
+      case WNW:
+        mux = &moduleLldI2cMultiplexer1;
+        _data.vcnld = &moduleLldProximity1;
+        _data.evtflags = MODULE_OS_IOEVENTFLAGS_IRINT2;
+        break;
+      case NNW:
+      case NNE:
+      case ENE:
+      case ESE:
+        mux = &moduleLldI2cMultiplexer2;
+        _data.vcnld = &moduleLldProximity2;
+        _data.evtflags = MODULE_OS_IOEVENTFLAGS_IRINT1;
+        break;
+      default:
+        break;
+    }
+    pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH0, _data.timeout);
+    _disableInterrupt(_data.vcnld);
+    pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH1, _data.timeout);
+    _disableInterrupt(_data.vcnld);
+    pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH2, _data.timeout);
+    _disableInterrupt(_data.vcnld);
+    pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH3, _data.timeout);
+    _disableInterrupt(_data.vcnld);
+    switch (sensor) {
+      case NNE:
+        pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH1, _data.timeout);
+        res = aosTestRun(stream, &_test, "north-northeast sensor (I2C #2)");
+        break;
+      case ENE:
+        pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH3, _data.timeout);
+        res = aosTestRun(stream, &_test, "east-northeast sensor (I2C #2)");
+        break;
+      case ESE:
+        pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH2, _data.timeout);
+        res = aosTestRun(stream, &_test, "east-southeast sensor (I2C #2)");
+        break;
+      case SSE:
+        pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH0, _data.timeout);
+        res = aosTestRun(stream, &_test, "south-southeast sensor (I2C #1)");
+        break;
+      case SSW:
+        pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH1, _data.timeout);
+        res = aosTestRun(stream, &_test, "south-southwest sensor (I2C #1)");
+        break;
+      case WSW:
+        pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH3, _data.timeout);
+        res = aosTestRun(stream, &_test, "west-southwest sensor (I2C #1)");
+        break;
+      case WNW:
+        pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH2, _data.timeout);
+        res = aosTestRun(stream, &_test, "west-northwest sensor (I2C #1)");
+        break;
+      case NNW:
+        pca9544a_lld_setchannel(mux, PCA9544A_LLD_CH0, _data.timeout);
+        res = aosTestRun(stream, &_test, "north-northwest sensor (I2C #2)");
+        break;
+      default:
+        break;
+    }
+    _data.vcnld = NULL;
+    _data.evtflags = 0;
+    if (result != NULL) {
+      *result = res;
+    }
+    return AOS_OK;
+  }
+  // handle invalid arguments
+  else {
+    // print help
+    chprintf(stream, "Usage: %s OPTION\n", argv[0]);
+    chprintf(stream, "Options:\n");
+    chprintf(stream, "  -nne\n");
+    chprintf(stream, "    Test north-northeast sensor.\n");
+    chprintf(stream, "  -ene\n");
+    chprintf(stream, "    Test east-northeast sensor.\n");
+    chprintf(stream, "  -ese\n");
+    chprintf(stream, "    Test east-southeast sensor.\n");
+    chprintf(stream, "  -sse\n");
+    chprintf(stream, "    Test south-southeast sensor.\n");
+    chprintf(stream, "  -ssw\n");
+    chprintf(stream, "    Test south-southwest sensor.\n");
+    chprintf(stream, "  -wsw\n");
+    chprintf(stream, "    Test west-southwest sensor.\n");
+    chprintf(stream, "  -wnw\n");
+    chprintf(stream, "    Test west-northwest sensor.\n");
+    chprintf(stream, "  -nnw\n");
+    chprintf(stream, "    Test north-northwest sensor.\n");
+    if (result != NULL) {
+      result->passed = 0;
+      result->failed = 0;
+    }
+    return AOS_INVALIDARGUMENTS;
+  }
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) && (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) */
diff --git a/modules/PowerManagement_1-2/test/VCNL4020/module_test_VCNL4020.h b/modules/PowerManagement_1-2/test/VCNL4020/module_test_VCNL4020.h
new file mode 100644
index 0000000..b10636e
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/VCNL4020/module_test_VCNL4020.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_VCNL4020_H
+#define MODULE_TEST_VCNL4020_H
+
+#include <amiroos.h>
+
+#if ((AMIROOS_CFG_TESTS_ENABLE == true) && (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR)) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestVcnl4020ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) && (BOARD_SENSORRING == BOARD_PROXIMITYSENSOR) */
+
+#endif /* MODULE_TEST_VCNL4020_H */
+
diff --git a/modules/PowerManagement_1-2/test/adc/module_test_adc.c b/modules/PowerManagement_1-2/test/adc/module_test_adc.c
new file mode 100644
index 0000000..8b51169
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/adc/module_test_adc.c
@@ -0,0 +1,71 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_adc.h>
+#include <aos_test_adc.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_adcdata_t _data = {
+  /* driver               */ &MODULE_HAL_ADC_VSYS,
+  /* ADC conversion group */ &moduleHalAdcVsysConversionGroup,
+};
+
+static AOS_TEST(_test, "ADC", "VSYS", moduleTestAdcShellCb, aosTestAdcFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestAdcShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/PowerManagement_1-2/test/adc/module_test_adc.h b/modules/PowerManagement_1-2/test/adc/module_test_adc.h
new file mode 100644
index 0000000..b049959
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/adc/module_test_adc.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_ADC_H
+#define MODULE_TEST_ADC_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestAdcShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_ADC_H */
+
diff --git a/modules/PowerManagement_1-2/test/bq241xx/module_test_bq241xx.c b/modules/PowerManagement_1-2/test/bq241xx/module_test_bq241xx.c
new file mode 100644
index 0000000..8ed149e
--- /dev/null
+++ b/modules/PowerManagement_1-2/test/bq241xx/module_test_bq241xx.c
@@ -0,0 +1,113 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_bq241xx.h>
+#include <aos_test_bq241xx.h>
+#include <string.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_bq241xxdata_t _data = {
+  /* driver   */ NULL,
+};
+
+static AOS_TEST(_test, "bq24103a", "battery charger", moduleTestBq241xxShellCb, aosTestBq241xxFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestBq241xxShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  enum {
+    UNKNOWN,
+    FRONT, REAR,
+  } charger = UNKNOWN;
+
+  // evaluate argument
+  if (argc == 2) {
+    if (strcmp(argv[1], "-f") == 0 || strcmp(argv[1], "--front") == 0) {
+      charger = FRONT;
+    } else if (strcmp(argv[1], "-r") == 0 || strcmp(argv[1], "--rear") == 0) {
+      charger = REAR;
+    }
+  }
+
+  // handle valid charger
+  if (charger != UNKNOWN) {
+    aos_testresult_t res = {0, 0};
+
+    switch (charger) {
+      case FRONT:
+        _data.driver = &moduleLldBatteryChargerFront;
+        res = aosTestRun(stream, &_test, "front battery");
+        _data.driver = NULL;
+        break;
+      case REAR:
+        _data.driver = &moduleLldBatteryChargerRear;
+        res = aosTestRun(stream, &_test, "rear battery");
+        _data.driver = NULL;
+        break;
+      default:
+        break;
+    }
+    if (result != NULL) {
+      *result = res;
+    }
+    return AOS_OK;
+  }
+  // handle invalid arguments
+  else {
+    // print help
+    chprintf(stream, "Usage: %s OPTION\n", argv[0]);
+    chprintf(stream, "Options:\n");
+    chprintf(stream, "  --front, -f\n");
+    chprintf(stream, "    Test the front battery charger.\n");
+    chprintf(stream, "  --rear, -r\n");
+    chprintf(stream, "    Test the rear battery charger.\n");
+    if (result != NULL) {
+      result->passed = 0;
+      result->failed = 0;
+    }
+    return AOS_INVALIDARGUMENTS;
+   }
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
